---
title: SVG animation with SMIL
slug: Web/SVG/SVG_animation_with_SMIL
tags:
  - Animation
  - Firefox 4
  - Gecko 2.0
  - SVG
  - SVG Animation
---
<div class="warning">
<p>Although Chrome 45 deprecated SMIL in favor of CSS animations and Web animations, the Chrome developers have since <a href="https://groups.google.com/a/chromium.org/d/msg/blink-dev/5o0yiO440LM/YGEJBsjUAwAJ">suspended</a> that deprecation.</p>
</div>

<p>Firefox 4 introduced support for animating <a href="/en/SVG" title="en/SVG">SVG</a> using <a class="external" href="http://www.w3.org/TR/REC-smil">Synchronized Multimedia Integration Language</a> (SMIL). SMIL allows you to:</p>

<ul>
 <li>animate the numeric attributes of an element (x, y, ...)</li>
 <li>animate transform attributes (translation or rotation)</li>
 <li>animate color attributes</li>
 <li>follow a motion path</li>
</ul>

<p>This is done adding an SVG element like <span class="author-g-shbl2alwmr0wm7ko">{{ SVGElement("animate") }}</span> inside the SVG element to animate. Below are examples for the four different ways.</p>

<h2 id="Animating_attributes_of_an_element">Animating attributes of an element</h2>

<p>The following example animates the <strong>cx</strong> attribute of a circle. To do so, we add an <span class="author-g-shbl2alwmr0wm7ko">{{ SVGElement("animate") }} element inside the </span><span class="author-g-shbl2alwmr0wm7ko">{{ SVGElement("circle") }} element. The important attributes for </span><span class="author-g-shbl2alwmr0wm7ko">{{ SVGElement("animate") }} are:</span></p>

<dl>
 <dt><strong>attributeName</strong></dt>
 <dd>The name of the attribute to animate.</dd>
 <dt>from</dt>
 <dd>The initial value of the attribute.</dd>
 <dt>to</dt>
 <dd>The final value.</dd>
 <dt>dur</dt>
 <dd>The duration of the animation (for example, write '5s' for 5 seconds).</dd>
</dl>

<p>If you want to animate more attributes inside the same element, just add more {{ SVGElement("animate") }} elements.</p>

<pre class="brush: html">&lt;svg width="300" height="100"&gt;
  &lt;title&gt;Attribute Animation with SMIL&lt;/title&gt;
  &lt;rect x="0" y="0" width="300" height="100" stroke="black" stroke-width="1" /&gt;
  &lt;circle cx="0" cy="50" r="15" fill="blue" stroke="black" stroke-width="1"&gt;
    &lt;animate
       attributeName="cx" from="0" to="500"
       dur="5s" repeatCount="indefinite" /&gt;
  &lt;/circle&gt;
&lt;/svg&gt;</pre>

<p>{{ EmbedLiveSample('Animating_attributes_of_an_element', '100%', 120) }}</p>

<h2 id="Animating_the_transform_attributes">Animating the transform attributes</h2>

<p><span class="author-g-shbl2alwmr0wm7ko">The {{ SVGElement("animateTransform") }} element let you animate <strong>transform</strong> attributes. This new element is necessary because we are not animating a simple attribute like <strong>x</strong> which is just a number. Rotation attributes look like this: <code>rotation(theta, x, y)</code>, where <code>theta</code> is the angle in degrees, and <code>x</code> and <code>y</code> are absolute positions. In the example below, we animate the center of the rotation and the angle.</span></p>

<pre class="brush: html">&lt;svg width="300" height="100"&gt;
  &lt;title&gt;SVG SMIL Animate with transform&lt;/title&gt;
  &lt;rect x="0" y="0" width="300" height="100" stroke="black" stroke-width="1" /&gt;
  &lt;rect x="0" y="50" width="15" height="34" fill="blue" stroke="black" stroke-width="1"&gt;
    &lt;animateTransform
       attributeName="transform"
       begin="0s"
       dur="20s"
       type="rotate"
       from="0 60 60"
       to="360 100 60"
       repeatCount="indefinite"
			/&gt;
  &lt;/rect&gt;
&lt;/svg&gt;
</pre>

<p>{{ EmbedLiveSample('Animating_the_transform_attributes', '100%', 120) }}</p>

<h2 id="Animation_following_a_path">Animation following a path</h2>

<p><span class="author-g-shbl2alwmr0wm7ko">The {{ SVGElement("animateMotion") }} element lets you animate an element position and rotation according to a path. </span>The path is defined the same way as in <span class="author-g-shbl2alwmr0wm7ko">{{ SVGElement("path") }}. You can set the attribute to define whether the object rotates following the tangent of the path. </span></p>

<h3 id="Example_1_Linear_motion">Example 1: Linear motion</h3>

<p>In this example, a blue circle bounces between the left and right edges of a black box, over and over again, indefinitely. The animation here is handled by the {{ SVGElement("animateMotion") }} element. In this case, we're establishing a path consisting of a <strong>M</strong>oveTo command to establish the starting point for the animation, then the <strong>H</strong>orizontal-line command to move the circle 300 pixels to the right, followed by the <strong>Z</strong> command, which closes the path, establishing a loop back to the beginning. By setting the value of the <strong>repeatCount</strong> attribute to <code>indefinite</code>, we indicate that the animation should loop forever, as long as the SVG image exists.</p>

<pre class="brush: html">&lt;svg xmlns="http://www.w3.org/2000/svg" width="300" height="100"&gt;
  &lt;title&gt;SVG SMIL Animate with Path&lt;/title&gt;
  &lt;rect x="0" y="0" width="300" height="100" stroke="black" stroke-width="1" /&gt;
  &lt;circle cx="0" cy="50" r="15" fill="blue" stroke="black" stroke-width="1"&gt;
    &lt;animateMotion
       path="M 0 0 H 300 Z"
       dur="3s" repeatCount="indefinite" /&gt;
  &lt;/circle&gt;
&lt;/svg&gt;
</pre>

<p>{{ EmbedLiveSample('Example_1_Linear_motion', '100%', 120) }}</p>

<p><a href="https://developer.mozilla.org/samples/svg/svganimdemo1.html">View live sample</a></p>

<h3 id="Example_2_Curved_motion">Example 2: Curved motion</h3>

<p>Same example as before with a curved path and following the direction of the path.</p>

<pre class="brush: html">&lt;svg width="300" height="100"&gt;
  &lt;title&gt;SVG SMIL Animate with Path&lt;/title&gt;
  &lt;rect x="0" y="0" width="300" height="100" stroke="black" stroke-width="1" /&gt;
  &lt;rect x="0" y="0" width="20" height="20" fill="blue" stroke="black" stroke-width="1"&gt;
    &lt;animateMotion
       path="M 250,80 H 50 Q 30,80 30,50 Q 30,20 50,20 H 250 Q 280,20,280,50 Q 280,80,250,80Z"
       dur="3s" repeatCount="indefinite" rotate="auto" /&gt;
  &lt;/rect&gt;
&lt;/svg&gt;
</pre>

<p>{{ EmbedLiveSample('Example_2_Curved_motion', '100%', 120) }}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en/SVG" title="en/SVG">SVG</a></li>
 <li><a class="external" href="http://www.w3.org/TR/SVG/animate.html">SVG Animation Specification</a></li>
 <li><a class="external" href="http://www.w3.org/TR/REC-smil">SMIL Specification</a></li>
</ul>
